unit nes;

interface
uses c6502,snd,Windows,fastdib, Messages,sysUtils,
     inifiles, mmsystem;
type PalType = array[0..63,1..3]of byte;

const  MINL = 0;
       MAXL = 238;
       SLPF  = 244;
       NO_DATA  = $FF;
  ROM_MIRROR  = 1;
  ROM_WRAM    = 2;
  ROM_TRAINER = 4;
  ROM_FOUR    = 8;
  PPU_InVBlank    = $80;
  PPU_InHBlank    = $80;
  PPU_SpHit       = $40;
  PPU_SpMax       = $20;
  PPU_WriteIgnore = $10;
  JOY_A      = $01;
  JOY_B      = $02;
  JOY_SELECT = $04;
  JOY_START  = $08;
  JOY_UP     = $10;
  JOY_DOWN   = $20;
  JOY_LEFT   = $40;
  JOY_RIGHT  = $80;
  V_FLIP     = $80;
  H_FLIP     = $40;
  SP_BACK    = $20;
  PSG_BASE   = 111860;

  BLACK_COLOR = 62;
 __Pal_ : array[0..63]of integer = (
 $1d1d1d,$230609,$2a0000,$270011,$1d0023,$04002a,$000029,$00021f,
 $000b10,$001100,$001400,$050f00,$170f06,$000000,$070707,$000000,
 $2f2f2f,$3b1c00,$3b0e08,$3c0020,$2f002f,$160039,$000a36,$031332,
 $001c22,$002500,$002a00,$0e2400,$222000,$090909,$000000,$000000,
 $3f3f3f,$3f2f0f,$3f2517,$3f2229,$3f1e3d,$2d1d3f,$181d3f,$0e263f,
 $0f2f3c,$043420,$123713,$263e16,$363a00,$212121,$000000,$000000,
 $3f3f3f,$3f392a,$3f3531,$3f3235,$3f313f,$36313f,$2c2f3f,$2a363f,
 $28393f,$283f38,$2f3c2a,$333f2c,$3c3f27,$353535,$000000,$000000);


    _Pal1 : paltype =
    (

   ($80,$80,$80), ($00,$00,$BB), ($37,$00,$BF), ($84,$00,$A6),
   ($BB,$00,$6A), ($B7,$00,$1E), ($B3,$00,$00), ($91,$26,$00),
   ($7B,$2B,$00), ($00,$3E,$00), ($00,$48,$0D), ($00,$3C,$22),
   ($00,$2F,$66), ($00,$00,$00), ($05,$05,$05), ($05,$05,$05),

   ($C8,$C8,$C8), ($00,$59,$FF), ($44,$3C,$FF), ($B7,$33,$CC),
   ($FF,$33,$AA), ($FF,$37,$5E), ($FF,$37,$1A), ($D5,$4B,$00),
   ($C4,$62,$00), ($3C,$7B,$00), ($1E,$84,$15), ($00,$95,$66),
   ($00,$84,$C4), ($11,$11,$11), ($09,$09,$09), ($09,$09,$09),

   ($FF,$FF,$FF), ($00,$95,$FF), ($6F,$84,$FF), ($D5,$6F,$FF),
   ($FF,$77,$CC), ($FF,$6F,$99), ($FF,$7B,$59), ($FF,$91,$5F),
   ($FF,$A2,$33), ($A6,$BF,$00), ($51,$D9,$6A), ($4D,$D5,$AE),
   ($00,$D9,$FF), ($66,$66,$66), ($0D,$0D,$0D), ($0D,$0D,$0D),

   ($FF,$FF,$FF), ($84,$BF,$FF), ($BB,$BB,$FF), ($D0,$BB,$FF),
   ($FF,$BF,$EA), ($FF,$BF,$CC), ($FF,$C4,$B7), ($FF,$CC,$AE),
   ($FF,$D9,$A2), ($CC,$E1,$99), ($AE,$EE,$B7), ($AA,$F7,$EE),
   ($B3,$EE,$FF), ($DD,$DD,$DD), ($11,$11,$11), ($11,$11,$11)
);

    _Pal2 : paltype =
    (

    ($68,$68,$68),($00,$40,$80),($00,$00,$80),($40,$00,$80),
    ($80,$00,$80),($80,$00,$40),($80,$00,$00),($55,$00,$00),
    ($40,$40,$00),($33,$50,$00),($00,$50,$00),($00,$50,$00),
    ($00,$40,$40),($00,$00,$00),($00,$00,$00),($00,$00,$00),
    ($98,$98,$98),($00,$80,$C0),($40,$40,$C0),($80,$00,$C0),
    ($C0,$00,$C0),($C0,$00,$80),($C0,$20,$20),($C0,$40,$00),
    ($80,$80,$00),($55,$80,$00),($00,$80,$00),($33,$80,$33),
    ($00,$80,$80),($00,$00,$00),($00,$00,$00),($00,$00,$00),
    ($D0,$D0,$D0),($40,$C0,$FF),($80,$80,$FF),($C0,$40,$FF),
    ($FF,$00,$FF),($FF,$40,$C0),($FF,$50,$50),($FF,$80,$40),
    ($C0,$C0,$00),($80,$C0,$00),($00,$C0,$00),($55,$C0,$55),
    ($00,$C0,$C0),($33,$33,$33),($00,$00,$00),($00,$00,$00),
    ($FF,$FF,$FF),($80,$FF,$FF),($C0,$C0,$FF),($FF,$80,$FF),
    ($FF,$40,$FF),($FF,$80,$FF),($FF,$80,$80),($FF,$C0,$80),
    ($FF,$FF,$40),($C0,$FF,$40),($40,$FF,$40),($AA,$FF,$AA),
    ($40,$FF,$FF),($99,$99,$99),($00,$00,$00),($00,$00,$00));


 type ines_head = record
    RomType : array[1..3] of char;
    Ctrl,
    PRGROM,
    CHRRAM,
    ROMctrl1,
    ROMctrl2 : char;
    Expansion : array[0..7] of char;
  end;

var
    CPUPeriod,    UPeriod,    UCount,    PrevLine,
    HitY : integer;    ScreenWidth,    ScreenHeight,
    CPUinstr,    FrameRate,    ScanLine:integer;
    RomFilename : string;
    RomHeader   : ines_head;
    _n_:integer = 0;
    Joypad1,
    Joypad2,
    Joypad1Read,
    Joypad2Read  : byte;
    PPU_PalChange,
    PPUSCROLL_Change,
    PPUADDR_FirstRead,
    PPUSCROLL_Toggle : boolean;
    ScrollX,
    ScrollY,
    PPUSCROLL_X2,
    PPUSCROLL_Y2 : byte;
    cpu : M6502;
    Rom_On,smooth : boolean;

type _pages = array [0..8] of PChar;

var
    inif:tinifile;
    Page,
    VPage : _pages;
    { Cartridge ROM }
    ROM,
    VROM  : pchar;
    VAddr : word;
    PPU    : Tbytearray;
    VRAM   : Tbytearray;
    SRAM   : Tbytearray;
    WRAM   : Tbytearray;
    PSG    : Tbytearray;
    RAM    : Tbytearray;
    ROMSize,VROMSize,
    ROMType,MMCType,
    Mirroring,MirrorXor:integer;
    BUTTON1_UP,BUTTON1_DOWN,
    BUTTON1_LEFT,BUTTON1_RIGHT,
    BUTTON1_A,BUTTON1_B,
    BUTTON1_START,BUTTON1_SELECT,
    BUTTON2_UP,BUTTON2_DOWN,
    BUTTON2_LEFT,BUTTON2_RIGHT,
    BUTTON2_A,BUTTON2_B,
    BUTTON2_START,BUTTON2_SELECT:integer;
  hFormat:THANDLE;
  pFormat:PWAVEFORMATEX;
  showbg : boolean = true;
  showsp : boolean = true;
  showfps : boolean = true;

        lentbl:aRRAY[0..15]oF intEGER = (
        5,10,20,40,80,30,7,14,
        8,12,24,48,96,36,8,16
        );
//  Angle:integer =0;

   ch,len:integer;
   WaveOut:HWAVEOUT;
   lpWaveHdr:PWAVEHDR;
   sndcount:integer;
   sndPeriod :integer= 244;
   sndlen:array[0..3]of byte;


    function MemoryReadOpcode(Addr : word) : byte;
    function MemoryReadByte(Addr : word) : byte;
    procedure MemoryWrite (Addr : word; value : byte);
    function cpuLoop : byte;
    procedure RunM(Cartridge : string);
    function  LoadNES(filename : string): boolean;
    function  InitNES: boolean;
    procedure ResetNES;
    procedure TrashNES;
    procedure IOWrite(A : word; V : byte);
    function  IORead(A : word): byte;
    procedure CheckKb;
    procedure DrawScreen;
    procedure init_e;
    function ReadBit(v, p : byte): boolean;
    procedure WriteBit(var v : byte; p : byte; bit : boolean);
    procedure freerom;
    procedure Load_State;
    procedure Save_State;
    procedure Set_Pal(no:integer);


    var
    _freq:integer = 0;
implementation

uses main,nes_mmc,nes_ppu;


procedure Set_Pal(no:integer);
var
i,r,g,b:integer;
begin
if no = 0 then
begin
  for i := 0 to 63 do
  begin
    r:=getrvalue(__pal_[i]);
    g:=getgvalue(__pal_[i]);
    b:=getbvalue(__pal_[i]);
    BackBuffer.Colors[i].r := r+20;//_Pal_[i, 1];
    BackBuffer.Colors[i].g := g+20;//_Pal_[i, 2];
    BackBuffer.Colors[i].b := b+20;//_Pal_[i, 3];
  end;
end;

if no = 1 then
begin
  for i := 0 to 63 do
  begin
    BackBuffer.Colors[i].r := _Pal1[i, 1];
    BackBuffer.Colors[i].g := _Pal1[i, 2];
    BackBuffer.Colors[i].b := _Pal1[i, 3];
  end;
end;

if no = 2 then
begin
  for i := 0 to 63 do
  begin
    BackBuffer.Colors[i].r := _Pal2[i, 1];
    BackBuffer.Colors[i].g := _Pal2[i, 2];
    BackBuffer.Colors[i].b := _Pal2[i, 3];
  end;
end;

end;


function ReadBit(v, p : byte): boolean;
begin
     Result := ((v shr p) and 1) = 1;
end; { ReadBit }

procedure WriteBit(var v : byte; p : byte; bit : boolean);
begin
  if bit then
    v := v or (1 shl p)
  else
    v := v and not(1 shl p);
end; { WriteBit }

procedure freerom;
begin
Rom_On := false;
trashnes;
end;

procedure initCpu;
begin
  {if smooth = true then
  CPUPeriod := 30//getcpuspeed;
  else} CPUPeriod := 100;

  { inizializza cpu }
  with cpu do
  begin
    A := 0;
    P := 0;
    X := 0;
    Y := 0;
    S := 0;
    PC.w  := 0;
    iPeriod  := CPUPeriod;
    ICount   := 0;
    IRequest := 0;
    AfterCLI := 0;
    IBackup  := 0;
    //void *User;
    TrapBadOps := 0;
    Trap  := 0;
    Trace := 0;
  end;
end;

procedure RunM(Cartridge : string);
begin
  FreeROM;
  if LoadNES(Cartridge) then
  begin
  Initsound(_hinst,44,255);
    if InitNES then
    begin
      ResetNes;
      Rom_On := true;
      Run6502(cpu);
      end;
  end;
end;

procedure ResetNES;
begin
  UPeriod := 2;
  UCount  := 0;
  { Joypads }
  Joypad1 := 0;
  Joypad2 := 0;
  Joypad1Read := 0;
  Joypad2Read := 0;
  { PPU register }
  PPU[0] := 0;
  PPU[1] := 0;
  PPU[2] := 0;
  PPU[3] := 0;
  VAddr  := 0;
  { Screen }
  PPUADDR_FirstRead  := true;
  PPUSCROLL_Toggle := false;
  scanline := 0;
  { Reset cpu }
  CPUinstr := 0;
  Reset6502(cpu);

end; { ResetNES }

procedure TrashNES;
var
  i : integer;
  BatteryName : string;
  BatteryFile : file;
begin
  if (ROMType and ROM_WRAM)<>0 then
  begin
    { Save backed memory }
    BatteryName := Copy(RomFilename, 1, Pos('.', RomFilename)) + 'sav';
   // Terminal.Lines.Add('Saving backed memory file "' + ExtractFilename(BatteryName) + '".');
    AssignFile(BatteryFile, BatteryName);
    ReWrite(BatteryFile, 1);
    BlockWrite(BatteryFile, WRAM, SizeOf(WRAM), i);
    CloseFile(BatteryFile);
  end;
  { azzero memoria }
  FillChar(VRAM, SizeOf(VRAM), $00);
  FillChar(SRAM, SizeOf(SRAM), $00);
  FillChar(WRAM, SizeOf(WRAM), $00);
  FillChar(RAM, SizeOf(RAM), $00);
  for i:=Low(Page) to High(Page) do
    Page[i] := nil;
  for i:=Low(VPage) to High(VPage) do
    VPage[i] := nil;
  if Assigned(ROM) then
  begin
    FreeMem(ROM);
    ROM := nil;
  end;
  if Assigned(VROM) then
  begin
    FreeMem(VROM);
    VROM := nil;
  end;
end; { TrashNES }

function InitNES: boolean;
var
  j : integer;
  BatteryName : string;
  BatteryFile : file;
begin
  if (ROMType and ROM_WRAM)<>0 then
  begin
    Page[3] := @WRAM;
    { Loading of backed memory }
    BatteryName := Copy(RomFilename, 1, Pos('.', RomFilename)) + 'sav';
    if FileExists(BatteryName) then
    begin
      AssignFile(BatteryFile, BatteryName);
      Reset(BatteryFile, 1);
      BlockRead(BatteryFile, WRAM, SizeOf(WRAM), j);
      CloseFile(BatteryFile);
    end;
  end;
  Page[0] := @RAM;
  Result := MMCInit(MMCType);
end; { InitNES }

function LoadNES(filename : string) : boolean;
var
  F : file;
  i, j,
  PRGBytes,
  CHRBytes,
  CartSize : integer;
begin

  RomFilename := ExtractFilename(filename);
  AssignFile(F, filename);
  Reset(F, 1);
  {Header}
  BlockRead(F, ROMHeader, SizeOf(ROMHeader), i);
  if (ROMHeader.RomType <> 'NES') then
  begin
  Messagebox(main_hwnd,'Unknown file format','Error',MB_OK);
  Result := false;
  Exit;
  end;

  ROMSize  := Ord(ROMHeader.PRGROM);
  VROMSize := Ord(ROMHeader.CHRRAM);
  ROMType  := Ord(ROMHeader.ROMctrl1);
  MMCType  := (Ord(ROMHeader.ROMctrl1) shr 4);
  CartSize := ROMSize shl 4 + VROMSize * 8;

  if ROMHeader.Expansion[0]=#0 then
  MMCType := MMCType or (Ord(ROMHeader.ROMctrl2) and $F0);
  Mirroring := (Ord(ROMHeader.ROMctrl1) and ROM_MIRROR);
  MirrorXor := $400 shl Mirroring; { Horizontal : $400; Vertical : $800}

  PRGBytes := $4000 * ROMSize;
  CHRBytes := $2000 * VROMSize;
  GetMem(ROM, PRGBytes + 1);
  GetMem(VROM, CHRBytes + 1);
  BlockRead(F, ROM^, PRGBytes, j);
  //gameimage := ROM;
  BlockRead(F, VROM^, CHRbytes, j);
  CloseFile(F);
//  rom_here := true;
  Result := true;
end; { LoadNES }


procedure autoframe;
var dwTime, dwNoDrawCount, dwTick, dwTickOld:DWORD;
begin
dwTick := 0;
dwNoDrawCount := 0;
dwTickold := 0;
// Auto Frame Skipping
   dwTime := timeGetTime;
while ((dwTime - dwTick) < trunc(500 * (UPeriod + 1)/ 60)) and (dwNoDrawCount=0) do
   begin
   Sleep(1);
   dwTime := timeGetTime;
   end;
   if ((dwTime - dwTick) >= trunc(1350*(UPeriod + 1)/ 60)) then
   begin
   // TRACE("%d\n", dwTime - dwTick);
   inc(dwNoDrawCount);
   if (dwNoDrawCount <= 4 div trunc(UPeriod + 1)) then
   begin
   dwTick := dwTime - trunc(dwTime+(1000.0/60.0*(UPeriod + 1)));
   end;
   end;
   dwNoDrawCount := 0;
   dwTick := dwTime - trunc(dwTime+ (1000.0/60.0*(UPeriod + 1)));
   while (dwTick = dwTickOld) do
   begin
   dwTime :=dwTime+ trunc(1000*(UPeriod + 1) div 60);
   dwTick := dwTime - trunc(dwTime+(1000.0/60.0*(UPeriod + 1)));
   // dwTick += 1000*(UPeriod + 1)/60;
  end;
   // TRACE("%d\n", dwTick - dwTickOld);
   dwTickOld := dwTick;
   //}
   // End Auto Frame Skip
end;





procedure CheckKeyboard(x:integer; bit:integer);  // auch im Hintergrund
var y: Cardinal;
data:Tkeyboardstate;
procedure Poll;
begin
end;
begin
//  Poll;
{Data[x] and $80 <> 0}
  if (GetKeystate(x) = -128) or (GetKeystate(x)  = -127) then
  WriteBit(Joypad1, bit, true)
  else
  WriteBit(Joypad1, bit, false);
end;


procedure CheckKb;
begin
  Joypad1 := 0;
  CheckKeyboard(BUTTON1_Right,7);
  CheckKeyboard(BUTTON1_Left,6);
  CheckKeyboard(BUTTON1_Down,5);
  CheckKeyboard(BUTTON1_Up,4);
  CheckKeyboard(BUTTON1_Start,3);
  CheckKeyboard(BUTTON1_Select,2);
  CheckKeyboard(BUTTON1_B,1);
  CheckKeyboard(BUTTON1_A,0);

{  CheckKeyboard(BUTTON2_Right,7);
  CheckKeyboard(BUTTON2_Left,6);
  CheckKeyboard(BUTTON2_Down,5);
  CheckKeyboard(BUTTON2_Up,4);
  CheckKeyboard(BUTTON2_Start,3);
  CheckKeyboard(BUTTON2_Select,2);
  CheckKeyboard(BUTTON2_B,1);
  CheckKeyboard(BUTTON2_A,0);       }
end; { CheckKb }



procedure DrawScreen;
var i:integer;
d:hdc;
b:hbrush;
p:hpen;

begin
if showfps = true then
begin
//textout(BackBuffer.hDC,1,1,pchar('fps:'+inttostr(trunc(dwframes))),4+length(inttostr(trunc(dwframes))));
end;
  d:=GetDC(main_hwnd);
  BackBuffer.Draw(d,0,0);
  ReleaseDC(main_hwnd,d);


end; { DrawScreen }


function getcpuspeed:integer;
var d:dword;
begin
d := timegettime;
result := trunc(d * 100 / 15500000);
end;

procedure init_e;
var
  i,r,g,b: Integer;
begin
   initcpu;
    { Read configuration }
  ReadConfig;

  ROM := nil;
  VROM := nil;
  set_pal(1);

  for i := 0 to 239 do
  begin
  PP[i] := backbuffer.scanlines[i];
  end;

end;


function MemoryReadByte(Addr: Word): Byte;
begin
  case (Addr shr 13) of
    0 : { $0000 -- RAM }
        Result := RAM[Addr and $7FF];
    1,  { $2000 -- PPU }
    2 : { $4000 -- PSG }
        Result := IORead(Addr);
    3 : { $6000 -- WRAM }
        Result := WRAM[Addr and $1FFF];
  else
    { $8000 -- ROM }
    Result := Ord(Page[Addr shr 13][Addr]);
  end;
end; { MemoryReadByte }

procedure MemoryWrite(Addr: Word; value: Byte);
begin
 // GameImage^[Addr] := value;
  case (Addr shr 13) of
    0 : { $0000 -- RAM }
        RAM[Addr and $7FF] := value;
    1,  { $2000 -- PPU }
    2 : { $4000 -- PSG }
        IOWrite(Addr, value);
    3 : { $6000 -- WRAM }
        WRAM[Addr and $1FFF] := value;
  else
    { $8000 -- ROM }
    MMCWrite(Addr, value);
  end;
end; { MemoryWrite }

function MemoryReadOpcode(Addr: Word): Byte;
begin
       Result := Ord(Page[Addr shr 13][Addr]);
end; { MemoryReadOpcode }

function  IORead(A : word): byte;
begin
  case A of
    { PPU }
    $2002 : begin { PPU Status }
              Result := PPU[2];
              PPU[2] := PPU[2] and not(PPU_InVBlank or PPU_SpHit);
            end;
    $2007 : begin
              if PPUADDR_FirstRead then
              begin
                PPUADDR_FirstRead := false;
                Result := NO_DATA;
                Exit;
              end;
              VAddr := VAddr and $3FFF;
              if (VAddr<$2000) then
                Result := Ord(VPage[VAddr shr 10][VAddr])
              else
                Result := VRAM[VAddr];
              if (PPU[0] and $04)<>0 then { INC32 }
                inc(VAddr, 32)
              else
                inc(VAddr);
            end;
    { PGS }
    $4000..$4015 :
            begin
              Result := PSG[A - $4000];
            end;
    { Joypad }
    $4016 : begin
              Result := ((Joypad1 shr Joypad1Read) and $01);
              Joypad1Read := (Joypad1Read + 1) and $07;
            end;
     $4017 : begin
              Result := (Joypad2 shr Joypad2Read) and $01;
              Joypad2Read := (Joypad2Read + 1) and $07;
            end;
    else
    begin
       Result := NO_DATA;
    end;
  end;
end; { IORead }


const	BASE_FREQ  = 3700000;
procedure ajust_vol;
begin
{var
j:char;
begin
tmp:=itofix((PSG[io.psg_ch][4]&15)*
((PSG[ch][5]and 15)+(PSG[ch][5]shr 4))*
((psg_volume and 15)+(io.psg_volume>>4)))/(6*32*32),tmp2=0;
for (j=0;j<32;j++,tmp2+=tmp)
snd_vol[io.psg_ch][j]=/*(signed char)(j-16)/*/fixtoi(tmp2);}
end;




procedure IOWrite(A : word; V : byte);
var
  ch,i : integer;

begin

  case A of
    $2000 : PPU[0] := V;
    $2001 : PPU[1] := V;
    $2003 : PPU[3] := V;
    $2004 : begin
              SRAM[PPU[3]] := V;
              inc(PPU[3]);
            end;
    $2005 : begin
              if not(PPUSCROLL_Toggle) then
                PPUSCROLL_X2 := V
              else if V<=239 then
                PPUSCROLL_Y2 := V;
              PPUSCROLL_Toggle := not(PPUSCROLL_Toggle);
              PPUSCROLL_Change := true
            end;
    $2006 : begin
              VAddr := (VAddr shl 8) or V;
              PPUADDR_FirstRead := true;
            end;
    $2007 : begin
              if (PPU[2] and PPU_WriteIgnore)=0 then
              begin
                VAddr := VAddr and $3FFF;
                VRAM[VAddr] := V;
              if ((VAddr and $3000)=$2000) then { Mirroring }
              begin
              VRAM[(VAddr xor MirrorXor) and $2FFF] := V;
              end;

              if (VAddr=$3F00) then
              begin
           //   VRAM[$3F00] := V;
              VRAM[$3F04] := V;
              VRAM[$3F08] := V;
              VRAM[$3F0C] := V;
              VRAM[$3F10] := V;
              VRAM[$3F14] := V;
              VRAM[$3F18] := V;
              VRAM[$3F1C] := V;
              _spal := false;
              end;

              if (VAddr=$3F10) then
              begin
              VRAM[$3F00] := V;
              VRAM[$3F04] := V;
              VRAM[$3F08] := V;
              VRAM[$3F0C] := V;
             // VRAM[$3F10] := V;
              VRAM[$3F14] := V;
              VRAM[$3F18] := V;
              VRAM[$3F1C] := V;
              _spal := true;
              end;

                if (PPU[0] and $04)<>0 then { INC32 }
                  inc(VAddr, 32)
                else
                  inc(VAddr);
              end;
              PPUADDR_FirstRead := false;
            end;
    { PSG }
    $4000,
    $4004,
    $4008,
    $400C : begin
              PSG[A - $4000] := V;
          //    SetVolume(A div 4,(V and 7)shl 5);
            end;
    $4001,
    $4005,
    $4009,
    $400D : begin
              A := A - $4000;
              PSG[A] := V;
              //SetVolume
              SetVolume(A div 4,(V and 7)shl 5);
            end;
    $4002,
    $4006,
    $400A,
    $400E : begin { Freq. Low }
            PSG[A - $4000] := V;
          //  SetVolume(A div 4,(V and 7)shl 5);
            end;
    $4003,
    $4007,
    $400B,
    $400F : begin { Freq. High }
          A := A - $4000;
          PSG[A] := V;
         ch := A div 4;
	 if (PSG[A-3] and $20)<> 0 then
         begin
	 PSG[$15]:=PSG[$15] or (1shl ch);
	 len := V shr 4;
	 if (V and 8)<>0 then
         begin
	 if (len=0)then len:=128;
	 end else len:=lentbl[len]
	 end else len := 0;
	 sndlen[ch]:=len;
	 _freq:=((V and 7)shl 8) or PSG[A-1];
	 _freq:=PSG_BASE div (_freq+1);

	SetFreq(ch,_freq);
      //	SetVolume(ch,(PSG[A-2]and 7)shl 5);


         end;
    $4010,
    $4011,
    $4012,
    $4013 : begin { PCM }
              PSG[A - $4000] := V;
//           Sound(ch,_freq,(PSG[A-2]and 7)shl 5);
            end;
    { DMA }
    $4014 : begin
              if V<$80 then
                CopyMemory(@SRAM, @RAM[(V and 7) shl 8], 256)
              else
                CopyMemory(@SRAM, PChar(Page[V shr 5][V shl 8]), 256)
            end;
    $4015 : begin
              for ch:=0 to 3 do
                if ((V shr ch) and 1)<>0 then
                begin { Enable sound }

                end
                else
                begin { disable sound }

                end;
              PSG[$15] := V;
            end;
    { Joypad }
    $4016 : begin
              if ((PSG[$16] and 1) and not(V and 1))<>0 then
              begin
                Joypad1Read := 0;
                Joypad2Read := 0;
              end;
              PSG[$16] := V;
            end;
    $4017 : begin
              PSG[$17] := V;
            end;
    else
    begin
    //  Terminal.Lines.Add(format('Ignore write at address $%4x', [A]));
    end;
  end;
end; { IOWrite }

function Sprite0y:integer;
var y:integer;
begin
	y:=SRAM[0];
	result := y+8;
end;




function ProcessMessage(var Msg: TMsg): Boolean;
var
  Handled: Boolean;
begin
  Result := False;
  if PeekMessage(Msg, 0, 0, 0, PM_REMOVE) then
  begin
    Result := True;
    if Msg.Message <> WM_QUIT then
    begin
      Handled := False;
        TranslateMessage(Msg);
        DispatchMessage(Msg);
      end;
  end;
end;

procedure ProcessMessages;
var
  Msg: TMsg;
begin
  while ProcessMessage(Msg) do {loop};
end;

procedure sndLoop;
var i,ch:integer;
begin
dec(sndcount);
if (sndcount<=0) then
begin
sndcount:=sndPeriod;
for ch:=0 to 4-1 do
begin
if (sndlen[ch] <> 0)then
begin
dec(sndlen[ch]);
if (sndlen[ch]=0) then
begin
PSG[$15] :=PSG[$15] and PSG[$15] xor (1 shl ch);
end;
end;
end;
end;

end;

function Vblank_On :boolean;
begin
if (PPU[0] and $80)<> 0 then result := true
else result := false;
end;

function cpuLoop : byte;
var i:integer;
begin
ScanLine := (ScanLine + 1) mod SLPF;
  Result := _n_;
  sndLoop;
  if (ScanLine = MINL) then
  begin
    PPU[2]:= PPU[2] and (PPU_InVBlank);
    PrevLine := MINL;
    HitY := Sprite0y;
  end
  else if (ScanLine = MAXL) then
  begin
    if UCount<>0 then
      asm dec UCount end
    else
    begin
      RefreshScreen(PrevLine, ScanLine);
      PrevLine := ScanLine + 1;
      UCount := Uperiod;
      drawscreen;
    end;
  end;
  if (ScanLine>=MINL) and (ScanLine<=MAXL) then
  begin
    if PPUSCROLL_Change then
    begin
      if UCount=0 then
      RefreshScreen(PrevLine, ScanLine - 1);
      ScrollX := PPUSCROLL_X2;
      ScrollY := PPUSCROLL_Y2;
      PrevLine := ScanLine;
      PPUSCROLL_Change := false;
    end;
    if ((PPU[1] and $10)<>0) and (ScanLine=HitY) then
    begin
      PPU[2] := PPU[2] or PPU_SpHit;
      if (PPU[0] and $40)<>0 then { Sprite Hit ON }
        _n_ := INT_NMI;
    end;
  end
  else
  if ScanLine=240 then
  begin

    CheckKb;
    PPU[2] := (PPU[2] and not(PPU_SpHit)) or PPU_InVBlank;
    PSG[$16] := PSG[$16] and $FD;
    if VBlank_on = true then Result := INT_NMI;
    ProcessMessages;
    Fps;
    if not Rom_On then   Result := INT_QUIT;
  end;

end;

procedure Save_State;
var
  i : integer;
  SaveName : string;
  SaveFile : file;
begin
    SaveName := Copy(RomFilename, 1, Pos('.', RomFilename)) + 'st';
    AssignFile(SaveFile,SaveName);
    ReWrite(SaveFile, 1);
    BlockWrite(SaveFile, RAM, SizeOf(RAM), i);
    BlockWrite(SaveFile, SRAM, SizeOf(SRAM), i);
    BlockWrite(SaveFile, VRAM, SizeOf(VRAM), i);

    CloseFile(SaveFile);
end;


procedure Load_State;
var
  i : integer;
  LoadName : string;
  LoadFile : file;
begin
    LoadName := Copy(RomFilename, 1, Pos('.', RomFilename)) + 'st';
    AssignFile(LoadFile,LoadName);
    Reset(LoadFile, 1);
    BlockRead(LoadFile, RAM, SizeOf(RAM), i);
    BlockRead(LoadFile, SRAM, SizeOf(SRAM), i);
    BlockRead(LoadFile, VRAM, SizeOf(VRAM), i);
    CloseFile(LoadFile);
end;


end.

